--[[ Below, you can edit the options for knUI.
	true = feature enabled
	false = feature disabled
	
	After changing a setting, you will need to '/console reloadui' for changes to take effect
]]

knUI_DB = nil
knUI_DB = {
	ScoreboardSummary = true,	-- A battlegrounds summary board
	AutoSellGrey = 		true,	-- AUTO sell grey items when a vendor window opens
	EasyDelete = 		true,	-- Delete your cursor item by pressing SHIFT & ALT
	LargerAuras = 		true,	-- If using deafult unit frames, will make YOUR buffs/debuffs, larger
	Tooltip = 			true,	-- Uses my custom tooltip

	Alerts = {
		ChatAlerts =		true,	-- An audible alert whenever you recieve an in game whisper
		WarlockHappyness =	true,	-- Deathcoil something why don't you?
		Healthstone = {				-- Remember to use your healthstone when below 40% life
			Enabled =		true,
			IconSize =		60,
			Anchors =		{ "CENTER", UIParent, "TOP", 0, -200 },
			Font =			{ "Interface\\Addons\\knUI\\resources\\graphics\\coolvetica rg.ttf", 100 },
			Message =		"",
			Threshold =		40, 	-- Health % before a message is given
		},
	},
	
	IS = {							-- Alerts with text & icons when important buff related things happen
		Enabled =	false,
		Text =		true,
		Icons =		true,
		Font =		{ "Interface\\Addons\\knUI\\resources\\graphics\\coolvetica rg.ttf", 20 },
	},
	
	InfoLeft = {
		Enabled =	true,
		Width =		593,
		Height =	32,
		Anchors =	{ "BottomLeft", "UIParent", "BottomLeft", 35, 20 },
		Font =		{ "Interface\\Addons\\knUI\\resources\\graphics\\coolvetica rg.ttf", 15 },
	},
	
	InfoRight = {
		Enabled =	true,
		Width =		593,
		Height =	32,
		Anchors =	{ "BottomRight", "UIParent", "BottomRight", -35, 20 },
		Font =		{ "Interface\\Addons\\knUI\\resources\\graphics\\coolvetica rg.ttf", 15 },
	},
	
	Box_1 = {
		Enabled =	true,
		Width =		593,
		Height =	168,
		Anchors =	{ "BottomLeft", "InfoLeft", "BottomLeft", 0, 0 },
		Font =		{ "Interface\\Addons\\knUI\\resources\\graphics\\coolvetica rg.ttf", 12 },
	},
	
	Box_2 = {
		Enabled =	true,
		Width =		593,
		Height =	168,
		Anchors =	{ "BottomLeft", "InfoRight", "BottomLeft", 0, 0 },
	},
	
	Box_3 = {
		Enabled =	false,
		Width =		593,
		Height =	150,
		Anchors =	{ "BottomRight", "Box_2", "TopRight", 0, 2 },
	},
	
	ActionBar = {
		Enabled =	true,
		Height =	75,
		Left =		{ "BottomLeft", "Box_1", "BottomRight", 5, 0 },
		Right =		{ "BottomRight", "Box_2", "BottomLeft", -5, 0 },
	},
	
	Minimap = {
		Enabled =		true,
		Width =			151,
		Height =		20,
		ZoneAnchors =	{ "TopRight", "UIParent", "TopRight", -10, -10 },
		MapAnchors =	{ "TopRight", "ZoneText", "BottomRight", -3, -10 },
		TimeAnchors =	{ "TopRight", "MinimapBorder", "BottomRight", -9, 18 },
		StatAnchors =	{ "Right", "MinimapTime", "Left", -3, 0 },
		Font =			{ "Interface\\Addons\\knUI\\resources\\graphics\\coolvetica rg.ttf", 12 },
	},
	
	
	MouseoverDebuff = {
		Enabled = 			true,			-- Adds player-only applied debuffs to the mouseover target
		IconSize =			22,
		BarGraphic =		"Interface\\AddOns\\knUI\\resources\\graphics\\BantoBar.tga",
		Font =				{ "Interface\\Addons\\knUI\\resources\\graphics\\coolvetica rg.ttf", 10 },
		Spells = {
			WARLOCK = 		{ "Fear", "Howl of Terror", "Banish", "Seduction", "Spell Lock", "Soul Stone", "Curse of Exhaustion", "Death Coil", },
			HUNTER = 		{ "Wyvern Sting", "Ice Trap", },
			WARRIOR = 		{ "Intimidating Shout", "Disarm", "Concussion Blow", "Silence", "Dazed", },
			PRIEST = 		{ "Psychic Scream", },
			ROGUE = 		{ "Sap", },
			SHAMAN = 		{ "Hex", },
			PALADIN = 		{},
			DEATHKNIGHT = 	{},
			DRUID = 		{ "Cyclone", "Entangling Roots", "Innervate", },
			MAGE = 			{ "Polymorph", },
		},
	},
}
