local PLAYER_NAME = UnitName("player"):lower()
local PLAYER_GUID = UnitGUID("player")
local CLASS = (select(2, UnitClass('player')))

-- ###################### Alerts when a player's name is spoken in any chat, or they are whispered to
if knUI_DB["Alerts"]["ChatAlerts"] then
	local f = CreateFrame('Frame')

	local events = {
		"CHAT_MSG_GUILD",
		"CHAT_MSG_BATTLEGROUND",
		"CHAT_MSG_BATTLEGROUND_LEADER",
		"CHAT_MSG_OFFICER",
		"CHAT_MSG_RAID",
		"CHAT_MSG_SAY",
		"CHAT_MSG_WHISPER",
		"CHAT_MSG_BN_WHISPER",
	}

	for i = 1, #events do
		f:RegisterEvent(events[i])
	end

	f:SetScript('OnEvent', function(self, event, ...)
		if event == 'CHAT_MSG_WHISPER' or event == 'CHAT_MSG_BN_WHISPER' then
			PlaySoundFile("Interface\\Addons\\knUI\\resources\\sounds\\notify.mp3")
		else
			if (...) == nil then return end
			
			if (...):lower():find(PLAYER_NAME) then
				PlaySoundFile("Interface\\Addons\\knUI\\resources\\sounds\\notify.mp3")
			end
		end
	end)
end

-- ###################### Some Warlock specific happyness!
if knUI_DB["Alerts"]["WarlockHappyness"] then
	if not (select(2, UnitClass("player"))) == "WARLOCK" then return end

	local f = CreateFrame("Frame")
	f:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

	local bear = CreateFrame("Frame", "HappyCoilBear", UIParent)
		bear:SetWidth(256); HappyCoilBear:SetHeight(256)
		bear:SetPoint("CENTER", UIParent, "TOP", 0, -200)

	local t = bear:CreateTexture(nil,"BACKGROUND")
		t:SetTexture("Interface\\Addons\\knUI\\resources\\graphics\\bear.blp")
		t:SetAllPoints(bear)
		bear.texture = t
		bear:Hide()

	f:SetScript("OnEvent", function (self, event, ...)
		local type, GUID = select(2, ...), select(3, ...)
		if GUID ~= PLAYER_GUID then return end
		
		if (event == "COMBAT_LOG_EVENT_UNFILTERED") then 
			if (type == "SPELL_DAMAGE") then
				local spellId, spellName, spellSchool = select(9, ...) 
				local amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing = select(12, ...) 
		 
				if spellName == "Death Coil" then 
					PlaySoundFile("Interface\\Addons\\knUI\\resources\\sounds\\care.mp3")
					HappyCoilBear:ClearAllPoints() 
					HappyCoilBear:SetPoint("CENTER", UIParent, "CENTER", random(-500, 500), random(-500, 500)) 
					UIFrameFadeOut(HappyCoilBear, 1, .3, 0) 
				end 
			end 
		end 
	 end)
	 --[[
	GameTooltip:SetScript("OnShow", function()
		if (GameTooltipTextLeft1:GetText() == "Death Coil") then
			local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo("Death Coil")

			GameTooltip:ClearLines()
			GameTooltip:AddDoubleLine("Happy Coil", rank, 1, 1, 1, 0.5, 0.5, 0.5)
			GameTooltip:AddDoubleLine(cost .." Mana", maxRange.." yd range", 1, 1, 1, 1, 1, 1)
			GameTooltip:AddDoubleLine("Instant cast", "2 min cooldown", 1, 1, 1, 1, 1, 1)
			GameTooltip:AddLine("Shoots the smiling face of a carebear at your enemy target, causing it to skip merrily for 3 seconds. The target gives health to the caster as a gift between friends.", 1, 1, .5, 1)
			GameTooltip:Show()
		end
	end)
	]]
 end
 
 
-- ###################### Remember to use that Healthstone!
if knUI_DB["Alerts"]["Healthstone"]["Enabled"] then
	local db = knUI_DB["Alerts"]["Healthstone"]
	
	local player_alerted = false
	local thresh = db["Threshold"]

	local f = CreateFrame("Frame")
	f:SetPoint(db["Anchors"][1], _G[db["Anchors"][2]], db["Anchors"][3], db["Anchors"][4], db["Anchors"][5])
	f:SetWidth(db.IconSize)
	f:SetHeight(db.IconSize)
	f:Hide()

	local t = f:CreateTexture(nil,"BACKGROUND")
		t:SetTexture("Interface\\Icons\\INV_Stone_04")
		t:SetAllPoints(f)
		f.texture = t

	local txt = f:CreateFontString(nil, "BACKGROUND")
		txt:SetFontObject(GameFontNormal)
		txt:SetWidth(1024); txt:SetHeight(40)
		txt:SetPoint("CENTER", f, "CENTER", 0, -100)
		txt:SetJustifyH("MIDDLE"); txt:SetJustifyV("MIDDLE")
		txt:SetFont(db["Font"][1], db["Font"][2], "OUTLINE")
		txt:SetText(db["Message"])
		txt:SetParent(f)

	f:RegisterEvent("UNIT_HEALTH")
	f:RegisterEvent("PLAYER_REGEN_ENABLED")

	f:SetScript('OnEvent', function(self, event, ...)
		if event == "PLAYER_REGEN_ENABLED" or GetItemCount("Healthstone") == 0 then
			f:Hide()
			return
		end
		
		local HP = ((UnitHealth("player") / UnitHealthMax("player"))*100)

		if player_alerted and HP > thresh then
			player_alerted = false; f:Hide()
		elseif (HP < thresh and not UnitIsDeadOrGhost("player") and not player_alerted) then
			UIFrameFadeIn(f, 2, 0, 1)
			player_alerted = true
		end
	end)
end

