local db = knUI_DB

--[[ #########################
           INFO LEFT BAR
	########################## ]]
if db["InfoLeft"].Enabled then
	local tmp, i = db["InfoLeft"], 1
	
	CreateFrame("Frame", "InfoLeft", knUI)
	knUI:CreatePanel(InfoLeft, tmp.Width, tmp.Height, tmp["Anchors"][1], _G[tmp["Anchors"][2]], tmp["Anchors"][3], tmp["Anchors"][4], tmp["Anchors"][5])
	InfoLeft:EnableMouse(true)
	InfoLeft:SetScript("OnEnter", function() knUI:UpdateGuildInfo(); knUI_SPEC = knUI:ReadTalentSpec() end)
	InfoLeft:SetScript("OnLeave", function() GameTooltip:Hide(); end)

	local left = InfoLeft:CreateFontString(nil, "OVERLAY")
	left:SetFont(tmp["Font"][1], tmp["Font"][2])
	left:SetPoint("Left", InfoLeft, "Left", 20, 0)
	left:SetTextColor(.6, .6, .6, 1)
	InfoLeft.LeftText = left
	
	local center = InfoLeft:CreateFontString(nil, "OVERLAY")
	center:SetFont(tmp["Font"][1], tmp["Font"][2])
	center:SetPoint("CENTER", InfoLeft, "Center", 0, 0)
	center:SetTextColor(.6, .6, .6, 1)
	InfoLeft.CenterText = center
	
	local right = InfoLeft:CreateFontString(nil, "OVERLAY")
	right:SetFont(tmp["Font"][1], tmp["Font"][2])
	right:SetPoint("Right", InfoLeft, "Right", -20, 0)
	right:SetTextColor(.6, .6, .6, 1)
	InfoLeft.RightText = right
end

--[[ #########################
           INFO RIGHT BAR
	########################## ]]
if db["InfoRight"].Enabled then
	local tmp, i = db["InfoRight"], 1
	
	CreateFrame("Frame", "InfoRight", knUI)
	knUI:CreatePanel(InfoRight, tmp.Width, tmp.Height, tmp["Anchors"][1], _G[tmp["Anchors"][2]], tmp["Anchors"][3], tmp["Anchors"][4], tmp["Anchors"][5])
	InfoRight:EnableMouse(true)
	InfoRight:SetScript("OnEnter", function() knUI:UpdatePCStats(); knUI_SPEC = knUI:ReadTalentSpec() end)
	InfoRight:SetScript("OnLeave", function() GameTooltip:Hide(); end)

	local left = InfoRight:CreateFontString(nil, "OVERLAY")
	left:SetFont(tmp["Font"][1], tmp["Font"][2])
	left:SetPoint("Left", InfoRight, "Left", 20, 0)
	left:SetTextColor(.6, .6, .6, 1)
	InfoRight.LeftText = left
	
	local center = InfoRight:CreateFontString(nil, "OVERLAY")
	center:SetFont(tmp["Font"][1], tmp["Font"][2])
	center:SetPoint("Center", InfoRight, "Center", 0, 0)
	center:SetTextColor(.6, .6, .6, 1)
	InfoRight.CenterText = center
	
	local right = InfoRight:CreateFontString(nil, "OVERLAY")
	right:SetFont(tmp["Font"][1], tmp["Font"][2])
	right:SetPoint("Right", InfoRight, "Right", -20, 0)
	right:SetTextColor(.6, .6, .6, 1)
	InfoRight.RightText = right
end

--[[ #########################
			BOX_1 BACKGROUND
	########################## ]]
if db["Box_1"].Enabled then
	local tmp = db["Box_1"]
	CreateFrame("Frame", "Box_1", knUI)
	knUI:CreatePanel(Box_1, tmp.Width, tmp.Height)
	Box_1:SetPoint(tmp["Anchors"][1], _G[tmp["Anchors"][2]], tmp["Anchors"][3], tmp["Anchors"][4], tmp["Anchors"][5])
	
	ChatFrame1:ClearAllPoints(); ChatFrame1:SetPoint("TopLeft", "Box_1", "TopLeft", 5, 0); ChatFrame1:SetPoint("BottomRight", "Box_1", "BottomRight", 0, 0)
end

--[[ #########################
           BOX_2 BACKGROUND
	########################## ]]
if db["Box_2"].Enabled then
	local tmp = db["Box_2"]
	CreateFrame("Frame", "Box_2", knUI)
	knUI:CreatePanel(Box_2, tmp.Width, tmp.Height)
	Box_2:SetPoint(tmp["Anchors"][1], _G[tmp["Anchors"][2]], tmp["Anchors"][3], tmp["Anchors"][4], tmp["Anchors"][5])
end

--[[ #########################
           BOX_3 BACKGROUND
	########################## ]]
if db["Box_3"].Enabled then
	local tmp = db["Box_3"]
	CreateFrame("Frame", "Box_3", knUI)
	knUI:CreatePanel(Box_3, tmp.Width, tmp.Height)
	Box_3:SetPoint(tmp["Anchors"][1], _G[tmp["Anchors"][2]], tmp["Anchors"][3], tmp["Anchors"][4], tmp["Anchors"][5])
end

--[[ #########################
           ACTIONBAR BACKGROUND
	########################## ]]
if db["ActionBar"] then 
	CreateFrame("Frame", "P_ActionBar", knUI)
	local tmp = db["ActionBar"]
	knUI:CreatePanel(P_ActionBar, 1, tmp.Height)
	P_ActionBar:SetPoint(tmp["Left"][1], _G[tmp["Left"][2]], tmp["Left"][3], tmp["Left"][4], tmp["Left"][5])
	P_ActionBar:SetPoint(tmp["Right"][1], _G[tmp["Right"][2]], tmp["Right"][3], tmp["Right"][4], tmp["Right"][5])
end

