
CreateFrame("Frame", "ChatModifications")
local hooks = {}
local dummy = function() end
local interval, label, stat = 0, "|cff999999", "|cffffffff"

local replaces = {
	["Guild"] = "(G)",
	["Party"] = "(P)",
	["Party Leader"] = "(PL)",
	["Dungeon Guide"] = "(DG)",
	["Raid"] = "(R)",
	["Raid Leader"] = "(RL)",
	["Raid Warning"] = "(!)",
	["Officer"] = "(O)",
	["Battleground"] = "(BG)",
	["Battleground Leader"] = "(BGL)",
}
	
local function addmessage(frame, text, red, green, blue, id)
	text = tostring(text) or ""
	for k,v in pairs(replaces) do
		text = text:gsub("|h%["..k.."%]|h", "|h"..v.."|h")
	end
	text = text:gsub("|h%[(%d+)%. .-%]|h", "|h%1|h")
	text = text:gsub("(|Hplayer.-|h)%[(.-)%]|h", "%1%2|h")
	text = text:gsub(" says:", ":")
	--text = text:gsub(" whispers:", " <")
	--text = text:gsub("To (|Hplayer.+|h):", "%1 >")
	--text = text:gsub("(|Hplayer.+|h) has earned the achievement (.+)!", "%1 ! %2")
	return hooks[frame](frame, text, red, green, blue, id)
end

local function hideframe(f)
	f.Show = dummy
	f:Hide()
end

function knUI:MakeChatModifications()
	local f = _G["ChatFrame1"]
	f:SetFading(false)
	f:EnableMouseWheel(true)
		_G["ChatFrame1"]:SetUserPlaced(true)
	f:SetScript("OnMouseWheel", function(frame, delta)
		if delta > 0 and IsShiftKeyDown() then
			frame:ScrollToTop()
		elseif delta > 0 then
			frame:ScrollUp()
		elseif delta < 0 and IsShiftKeyDown() then
			frame:ScrollToBottom()
		else
			frame:ScrollDown()
		end
	end)
	hooks[f] = f.AddMessage
	f.AddMessage = addmessage
end

function ChatModifications:OnMouseWheel()
	self.hooks[this]["OnMouseWheel"]()
	if delta > 0 then
		if IsShiftKeyDown() then this:ScrollToTop() else this:ScrollUp() end
	elseif delta < 0 then
		if IsShiftKeyDown() then this:ScrollToBottom() else this:ScrollDown() end
	end
end


local pn = UnitName("player"):lower()

ChatModifications:RegisterEvent("CHAT_MSG_GUILD")
ChatModifications:RegisterEvent("CHAT_MSG_BATTLEGROUND")
ChatModifications:RegisterEvent("CHAT_MSG_BATTLEGROUND_LEADER")
ChatModifications:RegisterEvent("CHAT_MSG_OFFICER")
ChatModifications:RegisterEvent("CHAT_MSG_RAID")
ChatModifications:RegisterEvent("CHAT_MSG_SAY")
ChatModifications:RegisterEvent("CHAT_MSG_WHISPER")
ChatModifications:RegisterEvent("CHAT_MSG_BN_WHISPER")

ChatModifications:SetScript('OnEvent', function(self, event, ...)
	if (not knUI_DB.Paranoia) then ChatModifications:SetScript('OnEvent', nil); return end
	
	if event == 'CHAT_MSG_WHISPER' then
		PlaySoundFile("Interface\\Addons\\knUI\\resources\\sounds\\notify.wav")
	else
		if ((...) == nil) then return end
		
		if (...):lower():find(pn) then
			PlaySoundFile("Interface\\Addons\\knUI\\resources\\sounds\\notify.wav")
		end
	end
end)


--[[ #########################
			KICKING SOME EDIT BOX ASS
	########################## ]]
local edit = CreateFrame("Frame", "ChatFrameEditBoxBackground", ChatFrame1EditBox)
knUI:CreatePanel(edit, 1, 1, "LEFT", "ChatFrame1EditBox", "LEFT", 0, 0)
edit:ClearAllPoints()
edit:SetAllPoints(ChatFrame1EditBox)
edit:SetBackdropBorderColor(.6, .6, 1, 1)
edit:SetFrameLevel(1)

for i = 1, NUM_CHAT_WINDOWS do
	local eb = _G['ChatFrame'..i..'EditBox']
	eb:Hide()
	--eb:HookScript('OnEnterPressed', function(s) s:Hide() end)
	eb:ClearAllPoints()
	eb:SetPoint("TopLeft", InfoLeft, "TopLeft", 0, 0)
	eb:SetPoint("BottomRight", InfoLeft, "BottomRight", 0, 0)
	eb:SetAltArrowKeyMode(nil)
	
	local x=({eb:GetRegions()})
	for i = 6, 12 do
		x[i]:SetAlpha(0)
	end
end

local function colorborder(r,g,b)
	ChatFrameEditBoxBackground:SetBackdropBorderColor(r,g,b)
end

hooksecurefunc("ChatEdit_UpdateHeader", function()
	local chat_type = DEFAULT_CHAT_FRAME.editBox:GetAttribute("chatType")
	
	if (chat_type == "CHANNEL") then
		local id = GetChannelName(DEFAULT_CHAT_FRAME.editBox:GetAttribute("channelTarget"))
		
		if id == 0 then
			colorborder(.6, .6, 1, 1)
		else
			colorborder(ChatTypeInfo[chat_type..id].r,ChatTypeInfo[chat_type..id].g,ChatTypeInfo[chat_type..id].b)
		end
	else
		colorborder(ChatTypeInfo[chat_type].r,ChatTypeInfo[chat_type].g,ChatTypeInfo[chat_type].b)
	end
end)

local _G = _G
local hooked = {}
--[[*** Settings Start***]]
local HideBorder = true -- Hides the editboxborder when not active
local UnClamp = false -- Make the window movable (take care! you can move it out of your screen)
local HideFriendButton = false -- Hide the friendsbutton
local Unsticky = false -- Dont remember whispers for next enter
--[[*** Settings End***]]

local function focusToggle(self)
	local name,tex = self:GetName()
	if(self:HasFocus()) then
		tex = _G[name..'Left']
		tex:Show()
		tex = _G[name..'Right']
		tex:Show()
		tex = _G[name..'Mid']
		tex:Show()
		self:Show()
	else
		tex = _G[name..'Left']
		tex:Hide()
		tex = _G[name..'Right']
		tex:Hide()
		tex = _G[name..'Mid']
		tex:Hide()	
		self:Hide()
	end
end

local function hookFrame(self)
	if(not hooked[self]) then
		self:HookScript("OnEditFocusGained",focusToggle)
		self:HookScript("OnEditFocusLost",focusToggle)
		hooked[self] = true
	end
	return
end

local function freechat()
	for i = 1, NUM_CHAT_WINDOWS do
		if(UnClamp) then
			local cf = _G['ChatFrame'..i]
			cf:SetClampedToScreen(false)
		end
		if(HideBorder) then
			local ef = _G['ChatFrame'..i..'EditBox']
			focusToggle(ef)
			hookFrame(ef)
		end
	end
	if(HideFriendButton) then
		local fb = _G['FriendsMicroButton']
		fb:UnregisterAllEvents()
		if(not hooked[fb]) then
			fb:HookScript("OnShow", function(self) self:Hide() end)
			hooked[fb] = true
		end
		fb:Hide()
	end
	if(Unsticky) then
		ChatTypeInfo['WHISPER']['sticky'] = 0
		ChatTypeInfo['BN_WHISPER']['sticky'] = 0
	end
end

local frame = CreateFrame("Frame")
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("UPDATE_CHAT_WINDOWS")
frame:SetScript("OnEvent", freechat)
