knUI = CreateFrame("Frame", "knUI", UIParent)
knUI:RegisterEvent("ADDON_LOADED")
knUI:RegisterEvent("PLAYER_ENTERING_WORLD")
knUI:RegisterEvent("PLAYER_TALENT_UPDATE")
knUI:RegisterEvent("PLAYER_LOGIN")
knUI_SPEC = nil

local _, class = UnitClass("player")

local mult = 768/string.match(GetCVar("gxResolution"), "%d+x(%d+)")/.64

local function scale(x)
    return mult*math.floor(x/mult+.5)
end

knUI:SetScript("OnEvent", function(self, event, ...)
	if (event == "ADDON_LOADED" and (...) == "knUI") then
		SlashCmdList["RANDOMPET"] = function() CallCompanion("CRITTER", random(GetNumCompanions("CRITTER") ) ) end
		SLASH_RANDOMPET1 = "/randompet"
		
		SlashCmdList["DISABLE_FFECTS"] = function() UIErrorsFrame:Hide(); SetCVar("Sound_EnableSFX", 0) end
		SLASH_DISABLE_FFECTS1 = "/de"

		SlashCmdList["ENABLE_EFFECTS"] = function() UIErrorsFrame:Clear(); UIErrorsFrame:Show(); SetCVar("Sound_EnableSFX", 1); end
		SLASH_ENABLE_EFFECTS1 = "/ee"
		
		SlashCmdList["SCOREBOARD_SUMMARY"] = function()
			if not WorldStateScoreFrame:IsVisible() then
				print("The Scoreboard frame must be visible for this command to work.")
			else
				SendChatMessage("Server count: Alliance "..#allyServers.." - Horde "..#hordeServers, "BATTLEGROUND")
			end
		end
		SLASH_SCOREBOARD_SUMMARY1 = "/ss"
		
		self:MakeChatModifications()

		ReputationWatchStatusBar:SetStatusBarTexture("Interface\\AddOns\\knUI\\resources\\graphics\\BantoBar.tga")
		MainMenuExpBar:SetStatusBarTexture("Interface\\AddOns\\knUI\\resources\\graphics\\BantoBar.tga")
	elseif (event == "PLAYER_TALENT_UPDATE" or event == "PLAYER_LOGIN") then
		knUI_SPEC = knUI:ReadTalentSpec()
	
	elseif (event == "PLAYER_ENTERING_WORLD") then
		ChatFrame_RemoveMessageGroup(ChatFrame1, "LOOT")
		ChatFrame_RemoveMessageGroup(ChatFrame1, "MONEY")
		ChatFrame_RemoveMessageGroup(ChatFrame1, "SKILL")
		ChatFrame_RemoveMessageGroup(ChatFrame1, "COMBAT_XP_GAIN")
		ChatFrame_RemoveMessageGroup(ChatFrame1, "COMBAT_HONOR_GAIN")
		ChatFrame_RemoveMessageGroup(ChatFrame1, "COMBAT_FACTION_CHANGE")
		
		self:UpdateMinimapZoneText()
		
		TimeManagerClockButton:Hide()
	end
end)

function knUI:ReadTalentSpec()
	if class == "DEATHKNIGHT" then
		local name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(1, 2)
		if currentRank > 0 then return "tank" else return "melee" end	
		
	elseif class == "DRUID" then
		local name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(2, 11)
		if currentRank > 0 then return "tank" end
		
		name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(2, 3)
		if currentRank > 0 then return "melee" end
		
		name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(1, 1)
		if currentRank > 0 then return "spell_dps" end
		
		return "healer"
		
	elseif class == "HUNTER" then
		return "ranged"
	
	elseif class == "PRIEST" then
		local name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(3, 2)
		if currentRank > 0 then return "spell_dps" end
		
		return "healer"
	
	elseif class == "WARLOCK" or class == "MAGE" then
		return "spell_dps"
		
	elseif class == "PALADIN" then
		local name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(2, 2)
		if currentRank > 0 then return "tank" end
		
		name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(3, 2)
		if currentRank > 0 then return "melee" end
		
		return "healer"
		
	elseif class == "ROGUE" then
		return "melee"
		
	elseif class == "SHAMAN" then
		local name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(2, 2)
		if currentRank > 0 then return "melee" end
		
		local name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(1, 3)
		if currentRank > 0 then return "spell_dps" end
		
		return "healer"
		
	elseif class == "WARRIOR" then
		local name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(3, 2)
		if currentRank > 0 then return "tank" end
		
		return "melee"
	end
end

function knUI:CreatePanel(f, w, h, a1, p, a2, x, y)
	sh = scale(h)
	sw = scale(w)
	if sh>3 and h==3 then sh=scale(2) end
	if sw>3 and w==3 then sw=scale(2) end
	f:SetFrameLevel(0)
	f:SetHeight(sh)
	f:SetWidth(sw)
	f:SetFrameStrata("BACKGROUND")
	if a1 then f:SetPoint(a1, _G[p], a2, x, y) end

	f:SetBackdrop({
	  bgFile = [[Interface\AddOns\knUI\resources\graphics\solid]], 
	  edgeFile = [[Interface\AddOns\knUI\resources\graphics\solid]], 
	  
	  tile = false, tileSize = 0, edgeSize = mult,
	  insets = { left = -mult, right = -mult, top = -mult, bottom = -mult}
	})
	f:SetBackdropColor(.1, .1, .1, 1)
	f:SetBackdropBorderColor(.25, .25, .25, 1)
end