EasyBuff = CreateFrame("Frame", "EasyBuff", UIParent)
EasyBuffButton = {}

local EasyBuffSpells = {
    WARLOCK = {
        "Detect Invisibility",
        "Unending Breath",
    },
    DRUID = {
        "Mark of the Wild",
        "Thorns",
    },
    PRIEST = {
        "Power Word: Fortitude",
        "Shadow Protection",
        "Divine Spirit",
    },
    MAGE = {
        "Arcane Intellect",
    },
    
    PALADIN = {},
    ROGUE = {},
    HUNTER = {},
    WARRIOR = {},
    SHAMAN = {},
	DEATHKNIGHT = {},
}

local EasyBuffSupers = {
    PRIEST = {
        "Prayer of Fortitude",
        "Prayer of Shadow Protection",
        "Prayer of Spirit",
    },
    DRUID = {
        "Gift of the Wild",
    },
    MAGE = {
        "Arcane Brilliance",
    },
    WARLOCK = {},
    PALADIN = {},
    ROGUE = {},
    HUNTER = {},
    WARRIOR = {},
    SHAMAN = {},
}

-- ONLY CALL IT ONCE, USE IT FOR EVAR
local _, class = UnitClass("player")
local CurrentEasyBuffSpells = EasyBuffSpells[class]
local CurrentEasyBuffSupers = EasyBuffSupers[class]
local created = false

-- ==============================================================
-- COUNT TOTAL ENTRIES IN A TABLE
-- ==============================================================
local function countEntries(tbl)
    local cnt = 0;
    for k in pairs(tbl) do cnt = cnt + 1; end
    return cnt
end

-- ==============================================================
-- FIND HIGHEST SPELL RANK
-- ==============================================================
local function GetSpellID(spell, rank)
	local i = 1
	local spellID
	local highestRank
	while true do
		local spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL)
		if (not spellName) then
			break
		end
		if (spellName == spell) then
			if (rank) then
				if (spellRank == rank) then
					return i
				end
			else
				spellID = i
				highestRank = spellRank
			end
		end
		i = i + 1
		if (i > 250) then
			break
		end
	end			
	return spellID, highestRank
end

-- ==============================================================
-- REGISTER ALL EVENTS TO USE
-- ==============================================================
EasyBuff:RegisterEvent("SPELL_UPDATE_COOLDOWN")
EasyBuff:RegisterEvent("ADDON_LOADED")
EasyBuff:RegisterEvent("PLAYER_ENTERING_WORLD")
EasyBuff:SetScript("OnEvent", function() EasyBuff:OnEvent(event) end)

-- ==============================================================
-- WHEN THE ADDON LOADS
-- ==============================================================
function EasyBuff:OnEvent(event)
	if (event == "ADDON_LOADED") then
	    

	elseif (event == "SPELL_UPDATE_COOLDOWN") then
	    for i = 1, countEntries(CurrentEasyBuffSpells) do
	        if not CurrentEasyBuffSpells[i] then return end
	        
	        local spellName = tostring(CurrentEasyBuffSpells[i])
	        if (GetSpellCooldown(spellName) ~= nil and GetSpellCooldown(spellName) > 0) then                
	            local start, duration, enable = GetSpellCooldown(spellName)
	            getglobal("EasyBuffButton"..i.."Cooldown"):SetCooldown(start, duration)
	        end
	    end
	
	elseif (event == "PLAYER_ENTERING_WORLD") then
		if not created then
			EasyBuffUpdate = CreateFrame("Frame", "EasyBuffUpdate", UIParent)
		    EasyBuffUpdate:SetScript("OnUpdate", function()
		        if InCombatLockdown() then return end
		        if not MinimalisqueDB['EasyBuff'] then return end
				if IsControlKeyDown() and IsAltKeyDown() then
			
					if countEntries(CurrentEasyBuffSpells) > 0 then
						EasyBuffParent:Show()
					end
				end
		    end)
		    
		    EasyBuffParent = CreateFrame("Frame", "EasyBuffParent", UIParent)
		    EasyBuffParent:SetWidth(170); EasyBuffParent:SetHeight(85)
		    EasyBuffParent:SetPoint("CENTER", UIParent, "CENTER", 0, 15)
			
		    EasyBuffParent:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", 
		                                --edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
		                                insets = { left = 5, right = 6, top = 6, bottom = 5 }}
		    )
			
		    EasyBuffParent:SetScript("OnMouseDown", function() EasyBuffParent:StartMoving() end)
		    EasyBuffParent:SetScript("OnMouseUp", function() EasyBuffParent:StopMovingOrSizing() end)
		    EasyBuffParent:SetScript("OnDragStop", function() EasyBuffParent:StopMovingOrSizing() end)
		    EasyBuffParent:EnableMouse(true); EasyBuffParent:SetMovable(true);
			
		    EasyBuffParentClose = CreateFrame("Button", "EasyBuffParentClose", EasyBuffParent, "UIPanelButtonTemplate")
		    EasyBuffParentClose:SetWidth(55); EasyBuffParentClose:SetHeight(25)
		    EasyBuffParentClose:SetPoint("TOPLEFT", EasyBuffParent, "TOPLEFT", 10, -7)
		    EasyBuffParentClose:SetScript("OnClick", function () EasyBuffParent:Hide() end)
		    EasyBuffParentClose:SetText("hide")
			
		    for x = 1, countEntries(CurrentEasyBuffSpells) do
		        EasyBuffButton[x] = CreateFrame("Button", "EasyBuffButton"..x, UIParent, "EasyBuffTemplate")
		        EasyBuffButton[x]:SetParent(EasyBuffParent)
		    end
		    
		    EasyBuff:CreateButtons()
		    EasyBuffParent:Hide()
			created = true
		end
	end
end

-- ==============================================================
-- CREATE BUTTONS
-- ==============================================================
function EasyBuff:CreateButtons()
    local width, height, scale = 60, 60, .636
    local LastButton = nil
	
    for i = 1, countEntries(CurrentEasyBuffSpells) do
		local button = getglobal("EasyBuffButton"..i)

        if GetSpellID(CurrentEasyBuffSpells[i]) then
            button:SetWidth(width); button:SetHeight(height); button:SetScale(scale); button:EnableMouse(true)
            
			if i then
				local width
				if i == 1 then
					width = (i * 57) + 16
				else
					width = (i * 54)
				end
				EasyBuffParent:SetWidth(width)
			end
			
            if not LastButton then
                button:SetPoint("CENTER", EasyBuffParent, "LEFT", 50, -20)
                LastButton = button
            else
                button:SetPoint("CENTER", LastButton, "RIGHT", 36, 0)
                LastButton = button
            end
			
            local spellString = tostring(CurrentEasyBuffSpells[i])
            button:SetScript("OnLeave", function() GameTooltip:Hide() end)
            button:SetScript("OnEnter", function()
                GameTooltip:SetOwner(this, "ANCHOR_CURSOR")
                GameTooltip:SetSpell(GetSpellID(spellString))
                GameTooltip:Show()
            end)

            local t = button:CreateTexture(nil,"BACKGROUND")
                t:SetTexture(GetSpellTexture(CurrentEasyBuffSpells[i]))
                t:SetAllPoints(button)
                button.texture = t
        else
            button:Hide()
        end
    end
end

-- ==============================================================
-- UPDATE BUTTON VERTEX COLORS
-- ==============================================================
function EasyBuff:Update()
    -- thanks to ckknight & navcaririel for the line below!
    local num = tonumber((this:GetName()):match("%d+"))
    local frame = getglobal("EasyBuffButton"..num).texture
    local spellName = tostring(CurrentEasyBuffSpells[num] or "")
    local usable, nomana = IsUsableSpell(spellName)
    
	-- CHANGE TO BLUE IF INSUFFICIENT MANA
    if nomana then
        frame:SetVertexColor(.1, .3, 1)
    
    -- CHANGE TO RED IF OUT OF RANGE HAS BEEN OMITTED, IT'S NOT REALLY NEEDED
    
    -- GREY OUT IF FLYING/DEAD/GHOST
    elseif UnitIsDeadOrGhost("player") or UnitOnTaxi("player") then
        frame:SetVertexColor(.3, .3, .3)
    
    -- CLEAR
    else
        frame:SetVertexColor(1, 1, 1)
    end
end

-- ==============================================================
-- CHECK A UNITS BUFFS
-- ==============================================================
function EasyBuff:UnitHasBuff(unit, buff)
	for i = 1, 40 do
		local name, rank, iconTexture, count, duration, timeLeft = UnitBuff(unit, i)
		if name then
			if name == buff then
				return true
			end
		end
	end
end

-- ==============================================================
-- WHERE THE MAGIC HAPPENS
-- ==============================================================
function EasyBuff:Magic(id, skip)
    local total, alone = 0, false
	local num = tonumber((id):match("%d+"))
    local person, raidID
    local hasBuff = false
	
    if UnitInRaid("player") then
		total = GetNumRaidMembers()
    elseif GetNumPartyMembers() > 0 then
		total = GetNumPartyMembers()
    else
		alone = true
    end

	if alone then
		if not EasyBuff:UnitHasBuff("player", CurrentEasyBuffSpells[num]) and not EasyBuff:UnitHasBuff("player", CurrentEasyBuffSupers[num]) then
			local button = getglobal("EasyBuffButton"..num)
			button:SetAttribute("type", "spell")
			button:SetAttribute("spell", CurrentEasyBuffSpells[num])
			button:SetAttribute("unit", "player")
			return
		end
	end
	
    for i = 1, total do
        if UnitInRaid("player") then
			person = UnitName("raid"..i)
			raidID = "raid"..i
        elseif UnitInParty("player") then
			person = UnitName("party"..i)
			raidID = "party"..i
        end
        
        if UnitIsVisible(raidID) and (IsSpellInRange(CurrentEasyBuffSpells[num], raidID) == 1) and not UnitIsDeadOrGhost(raidID) then
            if not EasyBuff:UnitHasBuff(raidID, CurrentEasyBuffSpells[num]) and not EasyBuff:UnitHasBuff(raidID, CurrentEasyBuffSupers[num]) then
                local button = getglobal("EasyBuffButton"..num)
                button:SetAttribute("type", "spell")
                button:SetAttribute("spell", CurrentEasyBuffSpells[num])
                button:SetAttribute("unit", raidID)
                Minimalisque:Spam(person..": "..CurrentEasyBuffSpells[num])
                return            
            end
        end
    end
end
