local PlayerName = UnitName('player')
local f = CreateFrame('Frame', 'WhatHappened', UIParent)
local WhatHappenedTotals = { damage = 0, avoided = 0, absorbed = 0, resisted = 0, blocked = 0, }

local ShortValue = function(value)
	if value >= 1e6 then
		return ("%.1fm"):format(value / 1e6):gsub("%.?0+([km])$", "%1")
	elseif value >= 1e3 or value <= -1e3 then
		return ("%.1fk"):format(value / 1e3):gsub("%.?0+([km])$", "%1")
	else
		return value
	end
end

f:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
f:RegisterEvent("PLAYER_REGEN_DISABLED")
f:RegisterEvent("PLAYER_REGEN_ENABLED")

f:SetScript("OnEvent", function(self, event, ...)
	if event == "PLAYER_REGEN_ENABLED" then
		if WhatHappenedTotals.damage == 0 then return end
		local MESSAGE = '|cffffffffTotal taken:|cffcc0033 '..ShortValue(WhatHappenedTotals.damage)
		if WhatHappenedTotals.avoided > 0 then MESSAGE = MESSAGE..' |cffffffffAvoided:|cffcc0033 '..ShortValue(WhatHappenedTotals.avoided) end
		if WhatHappenedTotals.absorbed > 0 then MESSAGE = MESSAGE..' |cffffffffAbsorbed:|cffcc0033 '..ShortValue(WhatHappenedTotals.absorbed) end
		if WhatHappenedTotals.resisted > 0 then MESSAGE = MESSAGE..' |cffffffffResisted:|cffcc0033 '..ShortValue(WhatHappenedTotals.resisted) end
		if WhatHappenedTotals.blocked > 0 then MESSAGE = MESSAGE..' |cffffffffBlocked:|cffcc0033 '..ShortValue(WhatHappenedTotals.blocked) end
		ChatFrame3:AddMessage(MESSAGE)
		
	elseif event == "PLAYER_REGEN_DISABLED" then
		WhatHappenedTotals = { damage = 0, avoided = 0, absorbed = 0, resisted = 0, blocked = 0, }
		
	else
		local timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags = select(1, ...)
		if destName ~= PlayerName then return end

		local dmg, totalAbsorbed, msg, spellname, DISPLAY = "", 0, "", "", false
		
		if type == "SWING_DAMAGE" or type == "RANGE_DAMAGE" then
			local amount, blocked, absorbed, critical  = (select(9, ...)), (select(13, ...)), (select(14, ...)), (select(15, ...))
			if absorbed ~= nil then totalAbsorbed = absorbed; msg = "a"; WhatHappenedTotals.absorbed = WhatHappenedTotals.absorbed + absorbed end
			if blocked ~= nil then totalAbsorbed = blocked; msg = "b"; WhatHappenedTotals.blocked = WhatHappenedTotals.blocked + blocked end
			
			if critical == 1 then dmg = "*"..dmg end
			dmg = "|cffffffff"..amount
			spellname = "|cffffffffMelee"
			WhatHappenedTotals.damage = WhatHappenedTotals.damage + amount
			DISPLAY = true
		elseif type == "DAMAGE_SPLIT" or type == "DAMAGE_SHIELD" or type == "SPELL_DAMAGE" or type == "SPELL_PERIODIC_DAMAGE" or type == "SPELL_DRAIN" or type == "SPELL_LEECH" or type == "SPELL_PERIODIC_DRAIN" or type == "SPELL_PERIODIC_LEECH" then
			local amount, resisted, absorbed, critical = (select(12, ...)), (select(15, ...)), (select(17, ...)), (select(18, ...))
			spellname = (select(10, ...))
			if absorbed ~= nil then totalAbsorbed = absorbed; msg = "a"; WhatHappenedTotals.absorbed = WhatHappenedTotals.absorbed + absorbed end
			if resisted ~= nil then totalAbsorbed = resisted; msg = "r"; WhatHappenedTotals.resisted = WhatHappenedTotals.resisted + resisted end
			if critical == 1 then dmg = "*"..dmg end
			
			if string.len(spellname) >= 17 then spellname = string.sub(spellname, 0, 14).."..." end
			
			dmg = "|cffcc0033"..amount
			spellname = "|cffcc0033"..(("%-17s"):format(spellname))
			WhatHappenedTotals.damage = WhatHappenedTotals.damage + amount
			DISPLAY = true
			
		elseif type == "SWING_MISSED" or type == "RANGE_MISSED" or type == "SPELL_MISSED" then
			WhatHappenedTotals.avoided = WhatHappenedTotals.avoided + 1
			return
		end
		
		if DISPLAY == true then
			dmg = (("%-10s"):format(dmg))
			if totalAbsorbed > 0 then dmg = dmg.." ("..totalAbsorbed.." "..msg..")" end
			
			if sourceName == nil then sourceName = "Unknown" end
			local NAME_LENGTH = string.len(sourceName)
			if NAME_LENGTH > 20 then sourceName = string.sub(sourceName, 0, 20)
			elseif NAME_LENGTH <= 19 then sourceName = string.sub(sourceName..string.rep(" ", NAME_LENGTH-20), 0, 20)
			end
			
			ChatFrame3:AddMessage("|cffff3333[|cffffffff"..(("%-20s"):format(sourceName)).."|cffff3333]|cffffffff"..string.rep(" ", 2)..dmg.." "..spellname)
		end
		
	end
end)

function WhatHappenedMsg(msg) ChatFrame3:AddMessage(msg) end