local db = knUI_DB["Healthstone"]

if not db.Enabled then return end

local PLAYER_ALERTED, thresh = false, db["Threshold"]

local f = CreateFrame("Frame", "Healthstone", UIParent)
f:SetPoint(db["Anchors"][1], _G[db["Anchors"][2]], db["Anchors"][3], db["Anchors"][4], db["Anchors"][5])
f:SetWidth(db.IconSize)
f:SetHeight(db.IconSize)

local t = f:CreateTexture(nil,"BACKGROUND")
	t:SetTexture("Interface\\Icons\\INV_Stone_04")
	t:SetAllPoints(f)
	f.texture = t

local txt = f:CreateFontString(nil, "BACKGROUND")
	txt:SetFontObject(GameFontNormal)
	txt:SetWidth(1024); txt:SetHeight(40)
	txt:SetPoint("CENTER", f, "CENTER", 0, -100)
	txt:SetJustifyH("MIDDLE"); txt:SetJustifyV("MIDDLE")
	txt:SetFont(db["Font"][1], db["Font"][2], "OUTLINE")
	txt:SetText(db["Message"])
	txt:SetParent(f)

f:RegisterEvent("UNIT_HEALTH")
f:RegisterEvent("PLAYER_REGEN_ENABLED")
f:Hide()


f:SetScript('OnEvent', function(self, event, ...)
	if event == "PLAYER_REGEN_ENABLED" or GetItemCount("Healthstone") == 0 then
		f:Hide()
		return
	end
	
	local HP = ((UnitHealth("player") / UnitHealthMax("player"))*100)

	if PLAYER_ALERTED and HP > thresh then
		PLAYER_ALERTED = false; f:Hide()
	elseif (HP < thresh and not UnitIsDeadOrGhost("player") and not PLAYER_ALERTED) then
		UIFrameFadeIn(f, 2, 0, 1)
		PLAYER_ALERTED = true
	end
end)