local _, class = UnitClass("player")
Pandorum_SPEC = nil


local f = CreateFrame("Frame", "TalentSpecUpdate")
f:RegisterEvent("PLAYER_TALENT_UPDATE")
f:RegisterEvent("PLAYER_LOGIN")
f:SetScript('OnEvent', function() Pandorum_SPEC = Pandorum:ReadTalentSpec() end)

function Pandorum:ReadTalentSpec()
	if class == "DEATHKNIGHT" then
		local name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(1, 2)
		if currentRank > 0 then return "tank" else return "melee" end	
		
	elseif class == "DRUID" then
		local name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(2, 11)
		if currentRank > 0 then return "tank" end
		
		name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(2, 3)
		if currentRank > 0 then return "melee" end
		
		name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(1, 1)
		if currentRank > 0 then return "spell_dps" end
		
		return "healer"
		
	elseif class == "HUNTER" then
		return "ranged"
	
	elseif class == "PRIEST" then
		local name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(3, 2)
		if currentRank > 0 then return "spell_dps" end
		
		return "healer"
	
	elseif class == "WARLOCK" or class == "MAGE" then
		return "spell_dps"
		
	elseif class == "PALADIN" then
		local name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(2, 2)
		if currentRank > 0 then return "tank" end
		
		name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(3, 2)
		if currentRank > 0 then return "melee" end
		
		return "healer"
		
	elseif class == "ROGUE" then
		return "melee"
		
	elseif class == "SHAMAN" then
		local name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(2, 2)
		if currentRank > 0 then return "melee" end
		
		local name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(1, 3)
		if currentRank > 0 then return "spell_dps" end
		
		return "healer"
		
	elseif class == "WARRIOR" then
		local name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq = GetTalentInfo(3, 2)
		if currentRank > 0 then return "tank" end
		
		return "melee"
	end
end

--[[ The code below is nearly all from ncUI ]]
local mult = 768/string.match(GetCVar("gxResolution"), "%d+x(%d+)")/.64

local function scale(x)
    return mult*math.floor(x/mult+.5)
end

function Pandorum:CreatePanel(f, w, h, a1, p, a2, x, y)
	sh = scale(h)
	sw = scale(w)
	if sh>3 and h==3 then sh=scale(2) end
	if sw>3 and w==3 then sw=scale(2) end
	f:SetFrameLevel(0)
	f:SetHeight(sh)
	f:SetWidth(sw)
	f:SetFrameStrata("BACKGROUND")
	if a1 then f:SetPoint(a1, _G[p], a2, x, y) end

	f:SetBackdrop({
	  bgFile = [[Interface\AddOns\Pandorum\gfx\solid]], 
	  edgeFile = [[Interface\AddOns\Pandorum\gfx\solid]], 
	  
	  tile = false, tileSize = 0, edgeSize = mult,
	  insets = { left = -mult, right = -mult, top = -mult, bottom = -mult}
	})
	f:SetBackdropColor(.1, .1, .1, 1)
	f:SetBackdropBorderColor(.25, .25, .25, 1)
end