if not knUI_DB["IS"].Enabled then return end

local Spells = {
	ALL_CLASSES = {
		{ SPELL_ID_LIST = { 2825 }, CONFLICTS = {}, "InCombatOnly", "FF0033" }, -- Bloodlust
		{ SPELL_ID_LIST = { 80353 }, CONFLICTS = {}, "InCombatOnly", "CCFFFF" }, -- Time Warp
		{ SPELL_ID_LIST = { 90355 }, CONFLICTS = {}, "InCombatOnly", "FFFFCC" }, -- Ancient Hysteria
		{ SPELL_ID_LIST = { 10060 }, CONFLICTS = {}, "InCombatOnly", "FF0033" }, -- Power Infusion
		{ SPELL_ID_LIST = { 29166 }, CONFLICTS = {}, "InCombatOnly", "006699" }, -- Innervate
	},
	WARLOCK = {
		{ SPELL_ID_LIST = { 63167, 63165 }, CONFLICTS = {}, "Either", "FF9933" }, -- Decimation
		{ SPELL_ID_LIST = { 28176 }, CONFLICTS = { 687 }, "InCombatOnly", "99FF33", "Missing"  }, -- Fel Armor
		{ SPELL_ID_LIST = { 687 }, CONFLICTS = { 28176 }, "InCombatOnly", "9900CC", "Missing"  }, -- Demon Armor
	},
	HUNTER = {
		{ SPELL_ID_LIST = { 5118 }, CONFLICTS = {}, "InCombatOnly", "FFFF00" }, -- Aspect of the Cheetah
		{ SPELL_ID_LIST = { 13159 }, CONFLICTS = {}, "InCombatOnly", "FFFFFF" }, -- Aspect of the Pack
		{ SPELL_ID_LIST = { 13165 }, CONFLICTS = {}, "InCombatOnly", "33CC00", "Missing" }, -- Aspect of the Pack
	},
	WARRIOR = {
		--{ SPELL_ID_LIST = { 46916 }, CONFLICTS = {}, "InCombatOnly", "FF3300" }, -- Slam!
		--{ SPELL_ID_LIST = { 469 }, CONFLICTS = { 6673, 6307, 21562 }, "InCombatOnly", "6699FF", "Missing", nil, "tank" }, -- Commanding Shout
		--{ SPELL_ID_LIST = { 6673 }, CONFLICTS = { 469 }, "InCombatOnly", "6699FF", "Missing", nil, "melee" }, -- Battle Shout
		{ SPELL_ID_LIST = { 871 }, CONFLICTS = {}, "Either", "666699" }, -- Shield Wall
		{ SPELL_ID_LIST = { 12976 }, CONFLICTS = {}, "Either", "FFFFCC" }, -- Last Stand
		{ SPELL_ID_LIST = { 55694 }, CONFLICTS = {}, "Either", "FF3366" }, -- Enraged Regeneration
	},
	DRUID = {
		--{ SPELL_ID_LIST = { 48518 }, CONFLICTS = {}, "InCombatOnly", "99CCFF", nil, "Cast Starfire!" }, -- Eclipse (Lunar)
		--{ SPELL_ID_LIST = { 48517 }, CONFLICTS = {}, "InCombatOnly", "66FF66", nil, "Cast Wrath!" }, -- Eclipse (Solar)
		--{ SPELL_ID_LIST = { 48391, 48392, 48393 }, CONFLICTS = {}, "InCombatOnly", "FF9933" }, -- Owlkin Frenzy!!!!!
	},
	PALADIN = {
		--{ SPELL_ID_LIST = { 58597 }, CONFLICTS = {}, "InCombatOnly", "FFFF33", "Missing", nil, "tank" }, -- Sacred Shield
	},
	DEATHKNIGHT = {
		--{ SPELL_ID_LIST = { 57330, 57623 }, CONFLICTS = {}, "InCombatOnly", "00CCCC", "Missing" }, -- Horn of Winter
	},
	ROGUE = {},
	SHAMAN = {
		{ SPELL_ID_LIST = { 324 }, CONFLICTS = { 52127 }, "InCombatOnly", "0099FF", "Missing", nil, "melee"  }, -- Lightning Shield
		{ SPELL_ID_LIST = { 52127 }, CONFLICTS = { 324 }, "InCombatOnly", "0066CC", "Missing", nil, "caster" }, -- Water Shield
	},
	MAGE = {},
	PRIEST = {
		{ SPELL_ID_LIST = { 63731, 63735 }, CONFLICTS = { 469, 6307 }, "InCombatOnly", "00FFFF" }, -- Serendipity
	},
}

local f = CreateFrame("Frame", "ImportantStuff")
	f:SetPoint('CENTER', UIParent)
	f:SetWidth(1); f:SetHeight(1)
	
local textArea = f:CreateFontString(nil, "OVERLAY")
	textArea:SetFontObject(GameFontNormalLarge)
	textArea:SetFont(knUI_DB.IS["Font"][1], knUI_DB.IS["Font"][2], "OUTLINE")
	textArea:SetWidth(500); textArea:SetHeight(100)
	textArea:SetPoint('CENTER', ImportantStuff)
	textArea:SetJustifyH("CENTER")
	textArea:SetJustifyV("BOTTOM")
	f.Text = textArea

--[[ The OnUpdate bit below was written by nightcracker, http://www.wowinterface.com/forums/showpost.php?p=177560&postcount=26 ]]
f.mult = 1
f.alpha = 1
f.tslu = 0 -- time since last update
f:SetScript("OnUpdate", function(self, elapsed)
	self.tslu = self.tslu + elapsed
	if self.tslu > .1 then
		self.tslu = 0
		self:SetAlpha(self.alpha)
	end
	self.alpha = self.alpha - elapsed*self.mult
	if self.alpha < 0 and self.mult > 0 then
		self.mult = self.mult*-1
		self.alpha = 0
	elseif self.alpha > 1 and self.mult < 0 then
		self.mult = self.mult*-1
	end
end)

local message
local _, class = UnitClass('player')
local SpellsQuery, AllClassesQuery = Spells[class], Spells["ALL_CLASSES"]
local count, all_classes_count = #SpellsQuery, #AllClassesQuery

local function add_to_list(INCOMING, combat_state)
	if combat_state == "InCombatOnly" and UnitAffectingCombat('player') or combat_state == "Either" then
		if message == nil then message = INCOMING
		else message = message.."\n\n"..INCOMING
		end
	elseif combat_state == "OutOfCombat" and not UnitAffectingCombat('player') then
		if message == nil then message = INCOMING
		else message = message.."\n\n"..INCOMING
		end
	end
end

CreateFrame("Frame", "ImportantStuffEvents")
ImportantStuffEvents:RegisterEvent("UNIT_AURA")
ImportantStuffEvents:RegisterEvent("PLAYER_REGEN_ENABLED")
ImportantStuffEvents:RegisterEvent("PLAYER_REGEN_DISABLED")
ImportantStuffEvents:SetScript('OnEvent', function(self, event, ...)
	if (...) ~= "player" then return end
	
	if event == "PLAYER_REGEN_ENABLED" and message == nil then
		ImportantStuff.Text:SetText(nil); ImportantStuff:Hide(); return
	end
	
	for i = 1, count do
		local Spell_ID_List = SpellsQuery[i]["SPELL_ID_LIST"]
		local Conflicts = SpellsQuery[i]["CONFLICTS"]
		local conflicted = false
		
		for k = 1, #Conflicts do
			if UnitAura("player", GetSpellInfo(Conflicts[k])) ~= nil then
				conflicted = true
			end
		end
		
		for j = 1, #Spell_ID_List do
			local spell_name = GetSpellInfo(Spell_ID_List[j])
			local combat_state, hex_color, state, display_text, talent_spec = unpack(SpellsQuery[i])
			local name, rank, icon_path, count,  dispelType, duration, expires, caster,  isStealable, shouldConsolidate, spellId = UnitAura('player', spell_name)
		
			icon_path = icon_path or select(3, GetSpellInfo(Spell_ID_List[j]))
			display_text = display_text or spell_name
			
			local icon = "|T"..icon_path..":12:12:0:0|t"
		
			if talent_spec ~= nil and talent_spec ~= knUI_SPEC then break end
		
			if spellId == Spell_ID_List[j] then
				if state == "Missing" then break end
				if not conflicted then
					local msg
					if knUI_DB["IS"].Text then msg = " |cff"..hex_color..display_text.." " end
					if knUI_DB["IS"].Icons then
						if msg == nil then msg = icon
						else msg = icon..msg..icon
						end
						add_to_list(msg, combat_state)
					end
				break
				end
			elseif state == "Missing" and name == nil then
				if not conflicted then
					local msg
					if knUI_DB["IS"].Text then msg = " |cff"..hex_color..display_text.." " end
					if knUI_DB["IS"].Icons then
						if msg == nil then msg = icon
						else msg = icon..msg..icon
						end
						add_to_list(msg, combat_state)
					end
				break
				end
			end
		end
	end

	for i = 1, all_classes_count do
		local Spell_ID_List = AllClassesQuery[i]["SPELL_ID_LIST"]
		local Conflicts = AllClassesQuery[i]["CONFLICTS"]
		local conflicted = false
		
		for k = 1, #Conflicts do
			local spell_name = GetSpellInfo(Conflicts[k])
			if UnitAura('player', spell_name) then
				conflicted = true
			end
		end
		
		for j = 1, #Spell_ID_List do
			local spell_name = GetSpellInfo(Spell_ID_List[j])
			local combat_state, hex_color, state, display_text, talent_spec = unpack(AllClassesQuery[i])
			local name, rank, icon_path, count,  dispelType, duration, expires, caster,  isStealable, shouldConsolidate, spellId  = UnitAura('player', spell_name)
		
			icon_path = icon_path or select(3, GetSpellInfo(Spell_ID_List[j]))
			display_text = display_text or spell_name
			
			local icon = "|T"..icon_path..":12:12:0:7|t"
		
			if talent_spec ~= nil and talent_spec ~= knUI_SPEC then break end
		
			if spellId == Spell_ID_List[j] then
				if state == "Missing" then break end
				if not conflicted then add_to_list(icon.." |cff"..hex_color..display_text.." "..icon, combat_state) end
				break
			elseif state == "Missing" and name == nil then
				if not conflicted then add_to_list(icon.." |cff"..hex_color..display_text.." "..icon, combat_state) end
				break
			end
		end
	end
	
	if message ~= nil then ImportantStuff:Show(); ImportantStuff.Text:SetText(message) else ImportantStuff.Text:SetText(nil); ImportantStuff:Hide() end
	message = nil
end)